{$R+,Q+}
uses
	sysutils, math, testlib;

const
	maxn = 30;
	eps = 1.1e-5;

var
	i, j, n: longint;
	x, y: array [1..maxn] of extended;
	jx, jy, ja, px, py, pa, d, da, a1, a2, dlow, dhigh, tmp: extended;
	an: array [1..maxn] of extended;
	js, ps: string;

begin
	js := ans.readstring;
	ps := ouf.readstring;

	if ps = 'impossible' then begin
		if js = 'impossible' then
			quit(_ok, 'impossible')
		else
			quit(_wa, 'impossible unexpected')
	end;

	if js = 'impossible' then
		quit(_wa, 'impossible expected');

	ouf.reset;
	ans.reset;

	n := inf.readlongint;
	dlow := inf.readlongint;
	dhigh := inf.readlongint;
	for i := 1 to n do begin
		x[i] := inf.readlongint;
		y[i] := inf.readlongint;
	end;

	jx := ans.readreal;
	jy := ans.readreal;

    for i := 1 to n do begin
      	an[i] := arctan2(y[i] - jy, x[i] - jx);
    end;

    for i := 1 to n do begin
      	for j := i + 1 to n do begin
        	if an[i] > an[j] then begin
          		tmp := an[i]; an[i] := an[j]; an[j] := tmp;
        	end;
      	end;
    end;

    ja := 0;
    for i := 1 to n do begin
        da := an[i mod n + 1] - an[i];
        if (da < -eps) then
          	da := da + 2 * pi;
        if (da > ja) then
          	ja := da;
    end;

    if ja > eps then
        ja := 2 * pi - ja;

	px := ouf.readreal;
	py := ouf.readreal;

	for i := 1 to n do begin
		d := hypot(x[i] - px, y[i] - py);
		if (d < dlow - eps) then
			quit(_wa, format('too close to sheep %d, distance: %.8f < %.8f', [i, d, dlow]));
		if (d > dhigh + eps) then
			quit(_wa, format('too far from sheep %d, distance: %.8f > %.8f', [i, d, dhigh]));
	end;

    for i := 1 to n do begin
      	an[i] := arctan2(y[i] - py, x[i] - px);
    end;

    for i := 1 to n do begin
      	for j := i + 1 to n do begin
        	if an[i] > an[j] then begin
          		tmp := an[i]; an[i] := an[j]; an[j] := tmp;
        	end;
      	end;
    end;

    pa := 0;
    for i := 1 to n do begin
        da := an[i mod n + 1] - an[i];
        if (da < -eps) then
          	da := da + 2 * pi;
        if (da > pa) then
          	pa := da;
    end;

    if (pa > eps) then
        pa := 2 * pi - pa;

	if (pa > ja + eps) then
		quit(_wa, format('expected: %.8f, found: %.8f', [ja, pa]));
	if (pa < ja - eps) then
		quit(_fail, format('expected: %.8f, found: %.8f', [ja, pa]));

	quit(_ok, format('(%.8f, %.8f), angle: %.8f', [px, py, pa]));
end.